Unit zf11e_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTZF11_p;

procedure zf11e(F :Func_F1E; A :Extended; B :Extended; EPS :Extended;
                NDIG :Integer; var ITMAX :Integer; var ROOT :Extended;
                var IERR :Integer);

implementation

procedure zf11e(F :Func_F1E; A :Extended; B :Extended; EPS :Extended;
                NDIG :Integer; var ITMAX :Integer; var ROOT :Extended;
                var IERR :Integer);
var
IC,NSIG :Integer;
FXL,FXR,FXAPP,EPSP,XL,XR,XAPP :Extended;
const
XMIN :Extended = 9.0e-18;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
XL := A;
XR := B;
NSIG := NDIG;
IERR := 0;
IC := 0;
if ( NDIG = 0 ) and ( EPS = 0.e0 ) 
 then NSIG := 5;
EPSP := Power(10.0e0,-NSIG);
FXL := F(XL);
FXR := F(XR);
XAPP := XL;
if ( FXL*FXR ) < 0
 then goto _3
 else if ( FXL*FXR ) > 0
       then goto _1
       else goto _2;
_1:
IERR := 66;
goto _8;
_2:
XAPP := XR;
if ( FXL = 0.0e0 ) 
 then XAPP := XL;
goto _8;
_3:
if ( Abs(FXL-FXR) <= XMIN ) 
 then goto _8;
XAPP := XL+FXL*(XR-XL)/(FXL-FXR);
FXAPP := F(XAPP);
if ( Abs(FXAPP) > Abs(EPS) ) 
 then goto _4;
goto _8;
_4:
if ( FXAPP*FXL > 0.0e0 ) 
 then goto _5;
XR := XAPP;
FXR := FXAPP;
goto _6;
_5:
XL := XAPP;
FXL := FXAPP;
_6:
if ( NSIG = 0 ) 
 then goto _7;
if ( XR-XL > EPSP*Abs(XR) ) 
 then goto _7;
goto _8;
_7:
IC := IC+1;
if ( IC <= ITMAX ) 
 then goto _3;
IERR := 65;
_8:
ITMAX := IC;
if ( IERR <> 0 ) 
 then goto _9;
ROOT := XAPP;
goto _10;
_9:
UTZF11(IERR,11);
_10:
end;

end.
